import * as t from '@babel/types';
import { AttributeValueFormatter } from '../helpers';
interface ComponentBuilderOptions {
    moduleRelativePath: string;
    platform: string;
    attributeValueFormatter: AttributeValueFormatter;
}
export declare function transformIntoAST(content: string, builderOpts: ComponentBuilderOptions): {
    output: t.Program;
    pathsToResolve: Array<string>;
};
export declare class ComponentBuilder {
    private openTags;
    private pathsToResolve;
    private usedNSTags;
    private options;
    private componentName;
    private moduleDirPath;
    private unsupportedPlatformTagCount;
    private treeIndex;
    private isComponentInitialized;
    private isInSlotFallbackScope;
    private moduleAst;
    private astConstructorBody;
    private astCustomModuleProperties;
    private astCustomModulesRegister;
    constructor(options: ComponentBuilderOptions);
    handleOpenTag(tagName: string, attributes: any): void;
    handleCloseTag(tagName: string): void;
    getModuleAst(): t.Program;
    getPathsToResolve(): string[];
    private finalize;
    private isClosingTag;
    private checkOpenTagNestingConditions;
    private traverseAttributes;
    private getAstForProperty;
    private buildComponentAst;
    private generateComponentInitializationAstBody;
    private generateScriptAndStyleBindingAst;
    private registerNamespace;
    private getLocalAndPrefixByName;
    private getResolvedPath;
    private isViewProperty;
}
export {};
